#!/bin/csh -f

# Specify the input file
set fileinp1  = example.ahkl

# Location of the anisotropy server script and programs
set binroot = /home/sawaya/data/anisotropyserver/doityourself_xds/bin

#Customized set of resolution limits for ellipsoidal truncation. Zero means the server will chose automatically
set alim = 0 
set blim = 0
set clim = 0

#Do you want to generate a new set of free R flags?
set freer = yes

#If so, specify the fraction of data to be used for the free R test set.
set freerfrac = 0.05

# Do you want the server to determine the B-factor value for sharpening?
set bauto = yes
set bother = 0.0

# output files. usually no need to change these
set fileout2  = phaser.log
set fileout3  = truncate.log
set fileout4  = results.ps
set fileout5  = etrunc.inp
set fileout6  = data.fin
set fileout7  = edata.ahkl
set fileout8  = f2mtz.inp
set fileout9  = edata.mtz
set fileout10 = aedata.log
set fileout11 = aedata
set fileout12 = cadbscale.inp
set fileout13 = baedata.mtz
set fileout14 = 4stepsdata.mtz
set fileout15 = pseudoprec.inp

rm $fileinp1.* 
rm $fileout7.*
rm $fileout11.*
rm $fileout14.*
rm exam_reslimit.dat
rm  XSCALE.INP $fileout2 $fileout3 $fileout4 $fileout4.png $fileout5 $fileout6 $fileout7 $fileout8 $fileout9 $fileout12 $fileout13 $fileout14 $fileout15  XSCALE.LP F2MTZ.INP
rm *.tmp

$binroot/anisotropyserver_xds $fileinp1  $fileout2  $fileout3  $fileout4  $fileout5  $fileout6 $fileout7  $fileout8  $fileout9  $fileout10  $fileout11  $fileout12  $fileout13  $fileout14  $fileout15 $alim $blim $clim $freer $freerfrac $bauto $bother $binroot

