c       read structure factors and plot pseupdo precession image
c       must first find out a*,b*, and c*, alpha beta gamma
c       and the max resolution limit in the data so graph will fit 
c       the page.  Get cell and resolution from etrunc log file.
	character orthobox*8,truncfile*80,phasrfile*80
        character etruncinp*80,fininfile*80,finoutfile*80
        character pseudoprecinp*80,cadinpfile*80
	character psfile*80,marker1*6,marker2*10,junk*80
        character marker3*17,f2mtzinp*80
        integer h,k,l,refnoinp,reject,rno
        real a,b,c,alpha,beta,gamma,pi
        real alphad,betad,gammad
        real sinalphastar,sinbetastar,singammastar
        real cosalphastar,cosbetastar,cosgammastar
        real loser(20),resol(20),sn1(20),sn2(20),sn3(20)
        real alim,blim,clim
        real f1,f2,f3,f4,s1,s2,s3,s4
        real scf,scl
        real x1,y1,negb
c
        write(*,*) 'Please type etrunc input file'
        read(*,'(a80)')etruncinp
        write(*,*) 'Type fin file with 4 data sets'
        read(*,'(a80)')fininfile
        write(*,*) 'Type output ps file'
        read(*,'(a80)')psfile
        write(*,*) 'Please type the pseudoprec input file'
        read(*,'(a80)')pseudoprecinp
        write(*,*) 'Please type the cad -B input file'
        read(*,'(a80)')cadinpfile
        open (1,file=etruncinp,status='old',form='formatted')
	open (2,file=fininfile,status='old',form='formatted')
	open (3,file=psfile,status='new',form='formatted')
	open (4,file=pseudoprecinp,status='old',form='formatted')
	open (5,file=cadinpfile,status='old',form='formatted')

c get unit cell and resolution limits from etrunc input file
    	read (1,3)junk
    	read (1,3)junk
   3	format(a80)
    	read (1,4)a,b,c,alphad,betad,gammad
   4    format(6f8.2)
    	read (1,3)junk
    	read (1,5)alim,blim,clim
   5    format(3f12.4)

c       We need to get a*,b*,c* for reciprocal cell dimensions and
c       we also need to get sin and cos of reciprocal cell angles
c       so we can assign x and y of each reciprocal lattice point
c       first convert degrees to radians because fortran
c       is so primitive, it cant handle degrees.
          pi=3.141592653589793
          alpha=alphad*pi/180.
          beta=betad*pi/180.
          gamma=gammad*pi/180.
c       calculate volume of unit cell which is needed to
c       calculate the reciprocal lattice dimensions, astar,bstar,cstar
          sq1=(cos(alpha))**2
          sq2=(cos(beta))**2
          sq3=(cos(gamma))**2
          sq4=2*(cos(alpha))*(cos(beta))*(cos(gamma))
          sqterm=sqrt(1-sq1-sq2-sq3+sq4)
          V=a*b*c*(sqterm)
c       calculate astar and bstar and cstar. see page 33 of stout n jensen
c       or see page 64 of Giacovazzo. Table 2.1
          astar=(b*c*sin(alpha))/V
          bstar=(a*c*sin(beta))/V
          cstar=(a*b*sin(gamma))/V
          print*,'a= ',a,' b= ',b,' c= ',c
          print*,'alpha= ',alphad,' beta= ',betad,' gamma= ',gammad
          print*,'astar= ',astar,' bstar= ',bstar,' cstar=',cstar
          print*, 'volume of direct unit cell= ',V
c    calculate reciprocal cell angles needed for orthogonalization matrix
c    See page 64 of Giacovazzo, table 2.1
          cosa=cos(alpha)
          cosb=cos(beta)
          cosg=cos(gamma)
          sina=sin(alpha)
          sinb=sin(beta)
          sing=sin(gamma)
          cosalphastar=((cosb*cosg)-cosa)/(sinb*sing)
          cosbetastar=((cosa*cosg)-cosb)/(sina*sing)
          cosgammastar=((cosa*cosb)-cosg)/(sina*sinb)
          sinalphastar= V/(a*b*c*sinb*sing)
          sinbetastar=  V/(a*b*c*sina*sing)
          singammastar= V/(a*b*c*sina*sinb)
          print*,'cosalpha*= ',cosalphastar
          print*,'cosbeta*= ',cosbetastar
          print*,'cosgamma*= ',cosgammastar
          print*,'sinalpha*= ',sinalphastar
          print*,'sinbeta*= ',sinbetastar
          print*,'singamma*= ',singammastar

c  sort out which axis has the highest resolution so you can scale the plot
        if((alim.le.blim).and.(alim.le.clim))then
          dmin=alim
          go to 45
        endif
        if((blim.le.alim).and.(blim.le.clim))then
          dmin=blim
          go to 45
        endif
        dmin=clim
  45    print*, 'limit on a* is', alim
        print*, 'limit on b* is', blim
        print*, 'limit on c* is', clim
        print*, 'maximum resolution is', dmin

c  write out the post script file header
        write (3,20)
  20    format ('%!PS')
        write (3,21)
  21    format ('%%BoundingBox: 0 -50 700 700')
        write (3,22)
  22    format ('%%PageBoundingBox: 0 -50 700 700')
        write (3,23)
  23    format ('0 setgray')

c  read in structure factors to find average F for each of the 4 data sets
c  Need this to set gray scale on output pseudo prec image
        refno=0
        f1sum=0
        f2sum=0
        f3sum=0
        f4sum=0
  80    read (2,83,end=85)h,k,l,f1,s1,f2,s2,f3,s3,f4,s4
  83    format(3i4,8f12.2)
        refno=refno+1
        f1sum=f1sum+f1
        f2sum=f2sum+f2
        f3sum=f3sum+f3
        f4sum=f4sum+f4
        avf1=f1sum/refno
        avf2=f2sum/refno
        avf3=f3sum/refno
        avf4=f4sum/refno
        go to 80
  85    print*,'ave|F|init,trunc,aniso,isob',avf1,avf2,avf3,avf4
        close (2)

c      Scale factor for magnifying the precession image
        scl=dmin*70.0
        print*, 'scaling the reciprocal cell by',scl
c       F/sigma threshold for coloring reflection red
        red=2.5

c  read in structure factors and make plots
c  read in structure factors and make plots
	open (2,file=fininfile,status='old',form='formatted')
  84    read (2,83,end=841)h,k,l,f1,s1,f2,s2,f3,s3,f4,s4
c  HERE WE PLOT H=0 for INITIAL DATA SET
c  HERE WE PLOT H=0 for INITIAL DATA SET
        if((h.eq.0).and.(f1.ne.0))then
c        plotting k on the x axis and l on the y axis
         x1=(cstar*l*scl*cosalphastar)+(bstar*k*scl)
         y1=(cstar*l*scl*sinalphastar)
c      Scale factor for grayness intensity
         if(f1/s1.gt.red)write(3,93)1.5-(f1/avf1)
         if(f1/s1.le.red)write(3,94)
  93     format(f8.3,' setgray')
  94     format('1 0 0 setrgbcolor')
         write(3,91) x1+150, y1+350
         write(3,91)-x1+150,-y1+350
  91     format(2f8.2,' 1 0 360 arc fill')
        endif

c  HERE WE PLOT H=0 for ETRUNCATED DATA SET
c  HERE WE PLOT H=0 for ETRUNCATED DATA SET
        if((h.eq.0).and.(f2.ne.0))then
c      Scale factor for grayness intensity
         if(f2/s2.gt.red)write(3,93)1.5-(f2/avf2)
         if(f2/s2.le.red)write(3,94)
         write(3,91) x1+300, y1+350
         write(3,91)-x1+300,-y1+350
        endif

c  HERE WE PLOT H=0 for ANISOTROPICALLY SCALED DATA SET
c  HERE WE PLOT H=0 for ANISOTROPICALLY SCALED DATA SET
        if((h.eq.0).and.(f3.ne.0))then
c      Scale factor for grayness intensity
         if(f3/s3.gt.red)write(3,93)1.5-(f3/avf3)
         if(f3/s3.le.red)write(3,94)
         write(3,91) x1+450, y1+350
         write(3,91)-x1+450,-y1+350
        endif

c  HERE WE PLOT H=0 for -B ISO SCALED DATA SET
c  HERE WE PLOT H=0 for -B ISO SCALED DATA SET
        if((h.eq.0).and.(f4.ne.0))then
c      Scale factor for grayness intensity
         if(f4/s4.gt.red)write(3,93)1.5-(f4/avf4)
         if(f4/s4.le.red)write(3,94)
         write(3,91) x1+600, y1+350
         write(3,91)-x1+600,-y1+350
        endif

c  HERE WE PLOT K=0 for INITIAL DATA SET
c  HERE WE PLOT K=0 for INITIAL DATA SET
        if((k.eq.0).and.(f1.ne.0))then
c        plotting h on the x axis and l on the y axis
         x1=(cstar*l*scl*cosbetastar)+(astar*h*scl)
         y1=(cstar*l*scl*sinbetastar)
c      Scale factor for grayness intensity
         if(f1/s1.gt.red)write(3,93)1.5-(f1/avf1)
         if(f1/s1.le.red)write(3,94)
         write(3,91) x1+150, y1+200
         write(3,91)-x1+150,-y1+200
        endif

c  HERE WE PLOT K=0 for ETRUNCATED DATA SET
c  HERE WE PLOT K=0 for ETRUNCATED DATA SET
        if((k.eq.0).and.(f2.ne.0))then
c      Scale factor for grayness intensity
         if(f2/s2.gt.red)write(3,93)1.5-(f2/avf2)
         if(f2/s2.le.red)write(3,94)
         write(3,91) x1+300, y1+200
         write(3,91)-x1+300,-y1+200
        endif

c  HERE WE PLOT K=0 for ANISOTROPICALLY SCALED DATA SET
c  HERE WE PLOT K=0 for ANISOTROPICALLY SCALED DATA SET
        if((k.eq.0).and.(f3.ne.0))then
c      Scale factor for grayness intensity
         if(f3/s3.gt.red)write(3,93)1.5-(f3/avf3)
         if(f3/s3.le.red)write(3,94)
         write(3,91) x1+450, y1+200
         write(3,91)-x1+450,-y1+200
        endif

c  HERE WE PLOT K=0 for -B ISO SCALED DATA SET
c  HERE WE PLOT K=0 for -B ISO SCALED DATA SET
        if((k.eq.0).and.(f4.ne.0))then
c      Scale factor for grayness intensity
         if(f4/s4.gt.red)write(3,93)1.5-(f4/avf4)
         if(f4/s4.le.red)write(3,94)
         write(3,91) x1+600, y1+200
         write(3,91)-x1+600,-y1+200
        endif



c  HERE WE PLOT L=0 for INITIAL DATA SET
c  HERE WE PLOT L=0 for INITIAL DATA SET
        if((l.eq.0).and.(f1.ne.0))then
c        plotting h on the x axis and k on the y axis
         x1=(bstar*k*scl*cosgammastar)+(astar*h*scl)
         y1=(bstar*k*scl*singammastar)
c      Scale factor for grayness intensity
         if(f1/s1.gt.red)write(3,93)1.5-(f1/avf1)
         if(f1/s1.le.red)write(3,94)
         write(3,91) x1+150, y1+ 50
         write(3,91)-x1+150,-y1+ 50
        endif

c  HERE WE PLOT L=0 for ETRUNCATED DATA SET
c  HERE WE PLOT L=0 for ETRUNCATED DATA SET
        if((l.eq.0).and.(f2.ne.0))then
c      Scale factor for grayness intensity
         if(f2/s2.gt.red)write(3,93)1.5-(f2/avf2)
         if(f2/s2.le.red)write(3,94)
         write(3,91) x1+300, y1+ 50
         write(3,91)-x1+300,-y1+ 50
        endif

c  HERE WE PLOT L=0 for ANISOTROPICALLY SCALED DATA SET
c  HERE WE PLOT L=0 for ANISOTROPICALLY SCALED DATA SET
        if((l.eq.0).and.(f3.ne.0))then
c      Scale factor for grayness intensity
         if(f3/s3.gt.red)write(3,93)1.5-(f3/avf3)
         if(f3/s3.le.red)write(3,94)
         write(3,91) x1+450, y1+ 50
         write(3,91)-x1+450,-y1+ 50
        endif

c  HERE WE PLOT L=0 for -B ISO SCALED DATA SET
c  HERE WE PLOT L=0 for -B ISO SCALED DATA SET
        if((l.eq.0).and.(f4.ne.0))then
c      Scale factor for grayness intensity
         if(f4/s4.gt.red)write(3,93)1.5-(f4/avf4)
         if(f4/s4.le.red)write(3,94)
         write(3,91) x1+600, y1+ 50
         write(3,91)-x1+600,-y1+ 50
        endif
        go to 84

c  print some useful information                                         
c  print some useful information                                         
 841    nof1=0
        nof2=0
        sumf1=0.0
        sums1=0.0
 104    read (4,103)refnoinp
 103    format(i9)
        read (4,103)reject
        read (4,102)avfos
 102    format(f12.2)
        read (4,103)rno
 105    write(3,106)
 106    format ('/Helvetica findfont')
        write (3,107)
 107    format ('15 scalefont setfont 0 0 0 setrgbcolor')
        write (3,108)
 108    format('30 670 moveto')
        write(3,109)refnoinp
 109   format('(',i10,' reflections were in the initial data set.)show')
        write(3,111)reject
 111   format('(',i10,' were discarded because they fell outside)show')
        write (3,110)
 110   format(' 40 650 moveto (the specified ellipsoid with dimensions')
        write(3,112)alim,blim,clim
 112   format('1/',f4.1,',   1/',f4.1,',   1/',f4.1)
        write(3,113)
 113   format(' A  along a*,b*,c*, respectively.')
        write(3,118)
 118   format(')show /Helvetica findfont 10 scalefont setfont')
        write(3,117)
 117   format('475 660 moveto (o -1)show ')
        write(3,106)
        write(3,107)
        write(3,114)
 114   format('40 630 moveto (These discarded reflections had an')
        write (3,115)avfos
 115   format('average F/sigma of',f6.2,'.)show')
        write (3,119)
 119   format('40 610 moveto')
        write(3,116)rno
 116   format('(',i10,' reflections remain after ellipsoidal')
        write(3,120)
 120   format('truncation.  Anisotropic scale factors were then) show')
        write(3,121)
 121   format('40 590 moveto (applied to remove anisotropy from the')
        read (5,3)junk
        read (5,123)negb
 123    format(24x,f12.3)
        write(3,122)negb
 122   format('data set.  Lastly, an isotropic B of',f8.2,' A)show')
        write(3,126)
 126   format('40 570 moveto (was applied to restore the magnitude')
        write(3,127)
 127   format('of the high resolution reflections diminished by')
        write(3,128)
 128   format(')show 40 550 moveto (anisotropic scaling.')
        write(3,170)
 170   format('The following pseudo precession images illustrate')
        write(3,171)
 171   format('the individual steps.)show')
        write(3,124)
 124   format('/Helvetica findfont 10 scalefont setfont')
        write(3,125)
 125   format('585 600 moveto (o 2)show ')
        print*, 'negB applied by cad was',negb
c    draw some lines and some key notation
        write(3,129)
 129    format('20 275 moveto 700 275 lineto stroke')
        write(3,130)
 130    format('20 125 moveto 700 125 lineto stroke')
        write(3,106)
        write(3,107)
        write(3,131)
 131    format('150 480 moveto (large magnitude F)show')
        write(3,160)
 160    format('stroke 140 485 5 0 360 arc fill ')
        write(3,132)
 132    format('0.6 setgray')
        write(3,133)
 133    format('300 480 moveto (small magnitude F)show')
        write(3,161)
 161    format('stroke 290 485 5 0 360 arc fill')
        write(3,94)
        write(3,134)
 134    format('450 480 moveto (F/sigma under 2.5)show')
        write(3,162)
 162    format('stroke 440 485 5 0 360 arc fill')
        write(3,106)
        write(3,107)
        write(3,135)
 135    format('180 420 moveto (TRUNCATION)show')
        write(3,136)
 136    format('320 440 moveto (ANISOTROPIC)show')
        write(3,138)
 138    format('340 420 moveto (SCALING)show')
        write(3,137)
 137    format('480 420 moveto (ISOTROPIC -B)show')
        write(3,142)
 142    format('3.0 setlinewidth')
        write(3,139)
 139    format('210 400 moveto 240 400 lineto stroke')
        write (3,143)
 143    format ('newpath 250 400 moveto -10 7 rlineto')
        write (3,144)
 144    format ('0 -14 rlineto closepath fill')
        write(3,140)
 140    format('350 400 moveto 380 400 lineto stroke')
        write (3,145)
 145    format ('newpath 390 400 moveto -10 7 rlineto')
        write (3,144)
        write (3,141)
 141    format('510 400 moveto 540 400 lineto stroke')
        write (3,147)
 147    format ('newpath 550 400 moveto -10 7 rlineto')
        write (3,144)
        write (3,148)
 148    format ('30 400 moveto (H=0) show')
        write (3,149)
 149    format ('30 250 moveto (K=0) show')
        write (3,150)
 150    format ('30 100 moveto (L=0) show')
        write (3,153)
 153    format('1 setlinewidth')
        write (3,151)
 151    format('120 470 moveto 470 0 rlineto 0 30 rlineto')
        write (3,152)
 152    format('-470 0 rlineto 0 -30 rlineto stroke')
        write (3,163)
 163    format(' /Helvetica findfont 10 scalefont setfont')
        write (3,154)
 154    format('10 380 moveto (b* horiz.)show')
        write (3,155)
 155    format('10 360 moveto (c* vert.)show')
        write (3,156)
 156    format('10 230 moveto (a* horiz.)show')
        write (3,157)
 157    format('10 210 moveto (c* vert.)show')
        write (3,158)
 158    format('10  80 moveto (a* horiz.)show')
        write (3,159)
 159    format('10  60 moveto (b* vert.)show')

c  end the plots end the plots end the plots end the plots end the plots
c  end the plots end the plots end the plots end the plots end the plots
 941    write (3,942)
 942    format ('showpage')

c       lalalalalalallalalalalalallalalalalalalalalalalalalalal
  11    print *, 'bye'
 999	stop
	end
